library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity mcm is
	port (start, clk: in std_logic;
	A,B: in std_logic_vector(7 downto 0);
	R: out std_logic_vector(7 downto 0);
	ready: out std_logic );
end mcm;

architecture beh of mcm is
type stati is (idle, init,comp, updateA, updateB, updateR);
signal S : stati:=idle;
signal selA,selB,writeA,writeB,writeR: std_logic;
signal minore,diversi: std_logic;
signal ma,mb: std_logic_vector(7 downto 0);
begin

	cu:  process(clk)
	begin
		if clk'event and clk = '0' then
			case S is
				when idle => if start = '1' then S <= init;
				             else S <= idle;
							 end if;
				when init => S <= comp;
				when comp => if diversi='1' and minore = '1' then
					          -- ma < mb
							  S <= updateA;
				             elsif diversi = '1' and minore = '0' then
					          -- ma > mb
					 		   S<=updateB;
							 elsif diversi='0' then 
								 --ma=mb
							  S<=updateR;
							 else S<= idle;
							 end if;
				when updateA => S<=comp;
				when updateB => S<=comp;
				when others => S<= idle;
			   end case;
		 end if;
	end process;
	
	process(S)
	begin
		case S is
			when idle =>
			 selA <= '0';
			 selB <= '0';
			 writeA<= '0';
			 writeB<= '0';
			 writeR<= '0';
			when init =>
			 selA <= '0';
			 selB <= '0';
			 writeA<= '1';
			 writeB<= '1';
			 writeR<= '0';
			when comp =>
			 selA <= '1';
			 selB <= '1';
			 writeA<= '0';
			 writeB<= '0';
			 writeR<= '0';
			when updateA =>
			 selA <= '1';
			 selB <= '1';
			 writeA<= '1';
			 writeB<= '0';
			 writeR<= '0';
			when updateB =>
			 selA <= '1';
			 selB <= '1';
			 writeA<= '0';
			 writeB<= '1';
			 writeR<= '0';
			when updateR =>
			 selA <= '1';
			 selB <= '1';
			 writeA<= '0';
			 writeB<= '0';
			 writeR<= '1';
		end case;
	end process; 
  
	
		
		
 minore <= '1' when ma<mb else
	       '0';	
 diversi <= '0' when ma=mb else 
	        '1';
	 	   
 process(clk)
 begin
	 if clk'event and clk='0' then
		 if writeA = '1' then
			 if selA= '0' then 
				    ma<=A;
			   else ma <= ma+A;
			 end if; 
		  end if;
		  
		if writeB = '1' then
			 if selB ='0' then
				 mb<= B;
			 else mb <= mb+B;
			 end if; 
		end if;
		
		if writeR = '1' then
			R<= ma;
		end if;
	end if;
   end process;
		
  process(S)
	begin
		if S=idle then
			ready<= '1';
		else ready <= '0';
		end if;
	end process;
	
		
	 
	
end beh;
