library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity mcm2 is
	port (start, clk: in std_logic;
	A,B: in std_logic_vector(7 downto 0);
	R: out std_logic_vector(7 downto 0);
	ready: out std_logic );
end mcm2;

architecture beh of mcm2 is
type stati is (idle, init,comp, updateR);
signal S : stati:=idle;
signal selAB,writeAB,writeR: std_logic;
signal diversi: std_logic;
signal ma,mb: std_logic_vector(7 downto 0);
begin

	cu:  process(clk)
	begin
		if clk'event and clk = '0' then
			case S is
				when idle => if start = '1' then S <= init;
				             else S <= idle;
							 end if;
				when init => S <= comp;
				when comp => if diversi='1'  then
					                S <= comp;
				             else   S<=updateR;
							 
							 end if;
				when others => S<= idle;
			   end case;
		 end if;
	end process;
	
	process(S)
	begin
		case S is
			when idle =>
			 selAB <= '0';
			 writeAB<= '0';
			 writeR<= '0';
			when init =>
			 selAB <= '0';
			 writeAB<= '1';
			 writeR<= '0';
			when comp =>
			 selAB <= '1';
			 writeAB<= '1';
			 writeR<= '0';
			when updateR =>
			 selAB <= '1';
			 writeAB<= '0';
			 writeR<= '1';
		end case;
	end process; 
  

 diversi <= '0' when ma=mb else 
	        '1';
	 	   
 process(clk)
 begin
	 if clk'event and clk='0' then
		 if writeAB = '1' then
			 if selAB= '0' then 
				 ma<=A;
				 mb<=B;
			 else if ma<mb then
				      ma <= ma+A; 
			      elsif ma > mb then
				      mb<= mb+B;
				  end if;
				   
			 end if; 
		  end if;
		  
				
		if writeR = '1' then
			R<= ma;
		end if;
	end if;
   end process;
		
  process(S)
	begin
		if S=idle then
			ready<= '1';
		else ready <= '0';
		end if;
	end process;
	
		
	 
	
end beh;
